#
# spec file for package w3m (Version 0.2.5)
#
# Copyright (c) 2003 SuSE Linux AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# neededforbuild  imlib imlib-devel libjpeg libpng-devel-packages libtiff libungif openssl openssl-devel xf86
# usedforbuild    aaa_base aaa_dir aaa_version base bash bindutil bison bzip cpio cpp cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm gppshare grep groff gzip kbd less m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam-devel pam-modules patch ps rcs readline sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim autoconf automake binutils cracklib gcc gdbm gettext imlib imlib-devel libjpeg libpng libpng-devel libtiff libtool libungif libz openssl openssl-devel pam perl rpm xdevel xf86 xshared

Name:         w3m
%define img_version 2.2
Version:      0.2.5
Release:      189
Summary:      Text based WWW browser
License:      Other License(s), see package
Group:        Productivity/Networking/Web/Browsers
Provides:     w3m_ssl web_browser
Obsoletes:    w3m_ssl
Autoreqprov:  on
Source:       http://prdownloads.sourceforge.net/w3m/w3m-%{version}.tar.bz2
## use newer version of the Boehm-Weiser garbage collector that supports s390
#Source1:      gc6.0alpha9.tar.bz2
BuildRoot:    %{_tmppath}/%{name}-%{version}-build
## fix from Thorsten (recognize sparc correctly)
Patch1:       w3m-0.2.1-sparc.dif
Patch2:       w3m-0.2.1-ia64.dif
Patch3:       http://sites.inka.de/mips/unix/distfiles/w3m-%{version}-img-%{img_version}.patch.bz2
Patch4:       WWW-Authenticate.dif
Patch10:      w3m-0.3.2-htmlquote-secfix.dif
Patch12:      w3m-0.3.2.2-textarea-segfault.dif
## Soudtrack: Stereo Deluxe

%description
w3m is a pager and text-based WWW browser. It is a similar application to
Lynx, but it has several features Lynx doesn't have:

* w3m can render tables
* w3m can render frames (it converts the frames into a table)
* SSL support
* w3m can display documents given from standard input easily
* w3m can handle cookies
* w3m is small
* you can use the mouse

When started as w3mj, it's in Japanese.

Authors:
--------
    Akinori Ito <aito@ei5sun.yz.yamagata-u.ac.jp>
    Hans-J. Boehm <boehm@acm.org>
    many other contributors, see /usr/share/doc/packages/w3m/gc/README

SuSE series: n

%prep
%setup -n w3m-%{version}
### use newer gc version that supports s390
#%ifarch s390 s390x
#  cp %{SOURCE1} .
#  rm -rf gc
#  tar xIf %{SOURCE1}
#%endif
## update autotools and libtool
DIR=$(find . -name configure -printf "%h\n")
%{?suse_update_config:%{suse_update_config -f $DIR }}
%ifarch sparc sparc64
%patch1
%endif
%patch2
%patch -P 3 -p1 -b .img
%patch10 -p1
%patch12 -p1

%build
## ./configure --bindir=/usr/bin --libdir=/usr/lib/w3m --sysconfigdir=/etc --helpdir=%{_defaultdocdir}/w3m --lang=en --cflags=... --model=monster    ## doesn't know all options, unfortunately
## build japanese binary first
(
  /bin/echo /usr/bin
  /bin/echo /usr/lib/w3m
  /bin/echo %{_defaultdocdir}/w3m
  /bin/echo /etc
  /bin/echo 1 ; # 1 = Japanese
  /bin/echo E ; # character set
  /bin/echo y ; # 2-byte character
  /bin/echo y ; # lynx-like key binding
  /bin/echo 5 ; # monster model
  /bin/echo y ; # SSL verification support
  /bin/echo y ; # Digest Auth support
  /bin/echo y ; # Inline image support
  /bin/echo y ; # ANSI color escape sequences support (new)
  /bin/echo y ; # Migemo (Roma-ji search)
  /bin/echo y ; # External URI loader support
  /bin/echo n ; # w3mmail.cgi
  /bin/echo y ; # NNTP support
  /bin/echo y ; # Gopher support
  /bin/echo y ; # Use alarm support code
  /bin/echo y ; # Use mark operation
  /bin/echo /usr/bin/vim
  /bin/echo /usr/bin/mutt
  /bin/echo /usr/X11R6/bin/netscape ; # external browser
#  /bin/echo /opt/kde2/bin/konqueror ; # external browser
  /bin/echo gcc
  /bin/echo -O		; # compiler flags
  /bin/echo -lncurses	; # terminal library
  /bin/echo		; # optional ld flags
) | ./configure
#
# this still needed?
#
#%ifarch sparc sparc64
#  ## struct sockaddr_storage seems to have no member ss_family on sparc
#  sed '/define INET6/d' config.h > config.h.new
#  mv config.h.new config.h
#%endif
%ifarch s390 s390x
  ## correct the include path for garbage collector (it's a hack...)
  sed 's+\(-I./gc/include\)+\1 -I./include +' config.h > config.h.new
  mv config.h.new config.h
%endif
make
mv w3m w3mj
make clean
## then english 
(
  /bin/echo /usr/bin
  /bin/echo /usr/lib/w3m
  /bin/echo %{_defaultdocdir}/w3m
  /bin/echo /etc
  /bin/echo 2 ; # 2 = English
  /bin/echo y
  /bin/echo 5
  /bin/echo y
  /bin/echo y 
  /bin/echo y
  /bin/echo y
  /bin/echo y
  /bin/echo y
  /bin/echo n
  /bin/echo y
  /bin/echo y
  /bin/echo y
  /bin/echo y
  /bin/echo /usr/bin/vim
  /bin/echo /usr/bin/mutt
  /bin/echo /usr/X11R6/bin/netscape
#  /bin/echo /opt/kde2/bin/konqueror
  /bin/echo gcc
  /bin/echo -O
  /bin/echo -lncurses
  /bin/echo 
) | ./configure
%ifarch sparc sparc64
  ## struct sockaddr_storage seems to have no member ss_family on sparc
  sed '/define INET6/d' config.h > config.h.new
  mv config.h.new config.h
%endif
make

%install
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;
mkdir $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man1
mkdir -p $RPM_BUILD_ROOT/%{_defaultdocdir}/w3m/doc/ 
mkdir -p $RPM_BUILD_ROOT/%{_defaultdocdir}/w3m/gc/
MANDIR=%{_mandir} DESTDIR=$RPM_BUILD_ROOT make install
install -m 755 w3mj $RPM_BUILD_ROOT/usr/bin
install -m 644	doc/w3m.1			$RPM_BUILD_ROOT/%{_mandir}/man1/
rm -rf doc/CVS
install -m 644	doc/*				$RPM_BUILD_ROOT/%{_defaultdocdir}/w3m/doc/
rm $RPM_BUILD_ROOT/%{_defaultdocdir}/w3m/doc/w3m.1
install -m 644	gc/doc/README{,.linux}	$RPM_BUILD_ROOT/%{_defaultdocdir}/w3m/gc/

%files
/usr/bin/w3m
/usr/bin/w3mj
/usr/lib/w3m/
%doc %{_mandir}/man1/w3m.1.gz
%docdir %{_defaultdocdir}/w3m
%doc %{_defaultdocdir}/w3m/*

%changelog -n w3m
* Mon Feb 24 2003 - poeml@suse.de
- fix a security bug where w3m will miss to escape html tag in 1)
  frame contents and 2) img alt attribute, so malicious frame html
  will deceive you to access your local files, cookies and so on
  (CAN-2002-1335, CAN-2002-1348)
- add fix for segfault that can occur when editing a textarea field
  with vi, and returning to w3m (it seems to happen if the terminal
  is not writable, as when using w3m after 'su - some_user')
  [#17597]
* Tue May 21 2002 - poeml@suse.de
- fix wrong configuration which broke HTML text area editing
  (editor was set to -O) (#16260)
* Sat Feb 02 2002 - poeml@suse.de
- update to 0.2.5:
  * RFC2617: HTTP Digest authentication
  * rc: default_url=0(empty) 1(current URL) 2(link URL)
  * GOTO_RELATIVE (M-u)
  * highlight for incremental search
  * support migemo (romaji search)
  * use w3mmail.cgi for mailto: URL
  * support external URI loader
  * support -dump_extra ftp://
  * new regex implementation
- update inline image patch to w3m-0.2.5-img-2.2.patch.bz2
- add WWW-Authenticate.dif (makes w3m recognize WWW-Authenticate:
  token in lower case)
* Fri Feb 01 2002 - ro@suse.de
- changed neededforbuild <libpng> to <libpng-devel-packages>
* Thu Jan 24 2002 - poeml@suse.de
- update to 0.2.4
- use updated inline image patch w3m-0.2.4-img-1.18.patch.gz
* Wed Nov 28 2001 - mfabian@suse.de
- add patch for inline images (tweaked to work with
  w3m-0.2.2-inu-1.1 by <tiwai@suse.de>,
  originally from http://www2u.biglobe.ne.jp/~hsaka/w3m/patch/)
* Fri Nov 23 2001 - poeml@suse.de
- update to w3m-0.2.2-inu-1.1. This time, the included gc is new
  enough (6.1alpha2), so we don't need to supply another one.
* Mon Nov 12 2001 - schwab@suse.de
- Fix for ia64.
* Wed Oct 31 2001 - poeml@suse.de
- update to w3m-0.2.1-inu-1.5. This includes almost all patches
  posted to w3m-dev ML and w3m-dev-en ML in Oct. For details, see:
  http://mi.med.tohoku.ac.jp/~satodai/w3m/inu/200110/index.en.html
* Tue Oct 30 2001 - poeml@suse.de
- update to latest version: w3m-0.2.1-inu-1.4 [w3m-dev-en 00596]
  (it is semi-official, but all developers use that one)
- drop all patches since they are now included
- w3m ships with current gc now, but update to gc6.0alpha9 which
  has some s390 patches
* Tue Aug 28 2001 - poeml@suse.de
- add w3m-0.2.1-javascript-hide.dif from author to hide javascript
  statements even if they are inside table tags
- apply forgotten relURL patch
* Thu Jun 28 2001 - poeml@suse.de
- security fix: w3m-0.2.1-mimehead-buf.dif to prevent possible
  buffer overflow when parsing malformed URLs
- add patch that allows key mappings with a count
- spec file cleanup
* Wed Apr 04 2001 - poeml@suse.de
- add patch to help with pages containing javascript
* Wed Apr 04 2001 - poeml@suse.de
- update to w3m-0.2.1
- as before, use a newer gc on ia64 and sparc
- fix include path for gc on ia64 and sparc
- undefine INET6 on sparc: struct sockaddr_storage seems to have no
  member ss_family
- fix double declaration of CMT_SSL_FORBID_METHOD
- add patch for problems caused by misunderstanding of relative
  URLs
- fix Version tag (was a macro)
* Mon Feb 19 2001 - poeml@suse.de
- update to 0.1.11-pre (which is actually more stable than 0.1.10)
- apply massive kokb23 patch collection
- add patch for lynx-like pauth option
- drop norman.patch
- add newer gc (6.0alpha6) for ia64 and sparc that works with
  glibc-2.2.1
- update autoconf and libtool on these archs
* Wed Jan 31 2001 - poeml@suse.de
- add a version 5.1 of gc (Boehm-Weiser garbage collector) which is
  patched for ia64 ( http://www.cs.berkeley.edu/projects/
  titanium/src/titaniumc/runtime/gc/ ).
  don't use GC_push_other_roots() for some reason -> gc-5.1.patch
* Tue Jan 09 2001 - poeml@suse.de
- removed duplicate man page in %%{_defaultdocdir}/w3m/doc/
* Wed Dec 20 2000 - poeml@suse.de
- add web_browser to Provides (in sync with lynx and links)
* Mon Dec 18 2000 - poeml@suse.de
- merged w3m and w3m_ssl
- added openssl to neededforbuild
- bzipped sources
* Wed Dec 06 2000 - poeml@suse.de
- added japanese binary
* Fri Oct 13 2000 - poeml@suse.de
- update to 0.1.10
- patch for perl path no longer necessary (now done by ./configure)
- fix missing ifdef JP_CHARSET
- readjust spec file to new option in ./configure
- compile with lynx-like key binding
* Sat Sep 09 2000 - bjacke@suse.de
- added Excludes with w3m_ssl
* Mon May 15 2000 - kukuk@suse.de
- Update to 0.1.9 (works on SPARC)
- Use /bin/vi for 7.0
- Fix defines on SPARC
- Fix spec file
- Add installed scripts to filelist
* Sun Feb 13 2000 - mge@suse.de
- update to 0.1.6
- group tag
* Tue Oct 26 1999 - mge@suse.de
- initial SuSE-RPM
